Index: uspace/app/getterm/Makefile
===================================================================
--- uspace/app/getterm/Makefile	(revision d52b00441cdabb1adcf0ee99c91a56217e472cd0)
+++ uspace/app/getterm/Makefile	(revision 4deb8b5597965bf2e7cb822f07fab72960edddfa)
@@ -34,5 +34,6 @@
 SOURCES = \
 	getterm.c \
-	version.c
+	version.c \
+	welcome.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/getterm/getterm.c
===================================================================
--- uspace/app/getterm/getterm.c	(revision d52b00441cdabb1adcf0ee99c91a56217e472cd0)
+++ uspace/app/getterm/getterm.c	(revision 4deb8b5597965bf2e7cb822f07fab72960edddfa)
@@ -43,4 +43,5 @@
 #include <errno.h>
 #include "version.h"
+#include "welcome.h"
 
 #define APP_NAME  "getterm"
@@ -48,5 +49,5 @@
 static void usage(void)
 {
-	printf("Usage: %s <terminal> <command> [<arguments...>]\n", APP_NAME);
+	printf("Usage: %s <terminal> [-w] <command> [<arguments...>]\n", APP_NAME);
 }
 
@@ -79,14 +80,33 @@
 	int retval;
 	task_id_t id;
-	char *fname;
+	char *fname, *term;
+	char **cmd_args;
+	bool print_wmsg;
 
-	if (argc < 3) {
+	++argv; --argc;
+	if (argc < 1) {
 		usage();
 		return -1;
 	}
+
+	if (str_cmp(*argv, "-w") == 0) {
+		print_wmsg = true;
+		++argv; --argc;
+	} else {
+		print_wmsg = false;
+	}
+
+	if (argc < 2) {
+		usage();
+		return -1;
+	}
+
+	term = *argv++;
+	fname = *argv;
+	cmd_args = argv;
 	
-	reopen(&stdin, 0, argv[1], O_RDONLY, "r");
-	reopen(&stdout, 1, argv[1], O_WRONLY, "w");
-	reopen(&stderr, 2, argv[1], O_WRONLY, "w");
+	reopen(&stdin, 0, term, O_RDONLY, "r");
+	reopen(&stdout, 1, term, O_WRONLY, "w");
+	reopen(&stderr, 2, term, O_WRONLY, "w");
 	
 	/*
@@ -105,8 +125,9 @@
 		return -4;
 	
-	version_print(argv[1]);
-	fname = argv[2];
-	
-	rc = task_spawnv(&id, fname, (const char * const *) &argv[2]);
+	version_print(term);
+	if (print_wmsg)
+		welcome_msg_print();
+
+	rc = task_spawnv(&id, fname, (const char * const *) cmd_args);
 	if (rc != EOK) {
 		printf("%s: Error spawning %s (%s)\n", APP_NAME, fname,
Index: uspace/app/getterm/welcome.c
===================================================================
--- uspace/app/getterm/welcome.c	(revision 4deb8b5597965bf2e7cb822f07fab72960edddfa)
+++ uspace/app/getterm/welcome.c	(revision 4deb8b5597965bf2e7cb822f07fab72960edddfa)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup getterm
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <stdio.h>
+#include "welcome.h"
+
+/** Welcome message and survival tips. */
+void welcome_msg_print(void)
+{
+	printf("Welcome to HelenOS!\n");
+	printf("http://www.helenos.org/\n\n");
+	printf("Type 'help' [Enter] to see a few survival tips.\n\n");
+}
+
+/** @}
+ */
Index: uspace/app/getterm/welcome.h
===================================================================
--- uspace/app/getterm/welcome.h	(revision 4deb8b5597965bf2e7cb822f07fab72960edddfa)
+++ uspace/app/getterm/welcome.h	(revision 4deb8b5597965bf2e7cb822f07fab72960edddfa)
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup getterm
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef WELCOME_H__
+#define WELCOME_H__
+
+extern void welcome_msg_print(void);
+
+#endif
+
+/** @}
+ */
